#define USE_TI89              // Compile for TI-89
#define USE_TI92PLUS          // Compile for TI-92 Plus
#define USE_V200              // Compile for V200
#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization
#define MIN_AMS 100           // Compile for AMS 1.00 or higher
#define SAVE_SCREEN           // Save/Restore LCD Contents
#include <tigcclib.h>         // Include All Header Files
#include "backgrounds.h"
#include "functions.h"
#include "models.h"
#include "drawline.h"
#include "credits.h"
#include "highscore.h"

//=========================================================//
short speed,bombsfalling=0,schiffx=100,explo,besiegt=0,ende;
 long int punkte;
const short anzahl;
struct bomben
   {
   short x;
   short y;
   };
struct bomben bombe[6];
struct ubootefeld
   {
   short x;
   short y;
   short sp;
   short richtung;
			   struct ubootschuss
			   {
			    short x;
			    short y;
			    short ausgeloest;
			   }uschuss;
   };
struct ubootefeld uboot[10];
//=========================================================//
void allnull(void)
{ 
short tt;
for (tt=0;tt<6;tt++)
 {
 	bombe[tt].x=0;
 	bombe[tt].y=0;
 } 
 for (tt=0;tt<=9;tt++)
 {
 	uboot[tt].x=0;
 	uboot[tt].y=0;
 } 
  for (tt=0;tt<10;tt++)
 {
 	uboot[tt].uschuss.ausgeloest=0;
 	uboot[tt].uschuss.x=0;
 	uboot[tt].uschuss.y=0;
 } 
}
void schiffbewegung()
{
 if (speed>0)
	 {
	  if (schiffx>=205) {schiffx=207;speed=0;}
	 	schiffx+=abs(speed);
	 	Sprite32 (schiffx, 23, 12, schiff1, GetPlane(1), A_OR);
	 }
	 if (speed<0)
	 {
	  if (schiffx<=4) {schiffx=2;speed=0;}
	 	schiffx-=abs(speed);
	 	Sprite32 (schiffx, 23, 12, schiff1, GetPlane(1), A_OR);
	 }
	 if (speed==0)
	 {
	 	Sprite32 (schiffx, 23, 12, schiff1, GetPlane(1), A_OR);
	 }
	 Sprite32 (schiffx, 23, 12, schiff1, GetPlane(1), A_XOR);

}
void schiffexplosion(void)
{
 explo++;
 zeit(9999);
 Sprite32 (schiffx, 23, 12, deluboot, GetPlane(1), A_XOR);
 if (explo==1) Sprite32 (schiffx, 23, 12, schiffexplode3, GetPlane(1), A_OR);
 if (explo==2) Sprite32 (schiffx, 23, 12, schiffexplode2, GetPlane(1), A_OR);
 if (explo==3) Sprite32 (schiffx, 23, 12, schiffexplode1, GetPlane(1), A_OR);
 if (explo==4) Sprite32 (schiffx, 23, 12, schiffexplode1, GetPlane(1), A_OR);
 if (explo==5) Sprite32 (schiffx, 23, 12, schiffexplode2, GetPlane(1), A_OR);
 if (explo==6) Sprite32 (schiffx, 23, 12, schiffexplode3, GetPlane(1), A_OR);
 if (explo==7) {besiegt=1; ende=1;}
}

//=========================================================//
//=========================================================//
//=========================================================//
void game(void)
{
 short key=0,schiffleben;
 int xp,zp,yp,wp;
 punkte=0;
 ende=0;
 clrscr();
 schiffleben=40;
 besiegt=0;
 do
 {
 allnull();
  FontSetSys(F_4x6);
 short tt,numbombs,bb=1,cc=0,first=0,kk,zz,saveuboote,saveu,explosion=0;
 short lry[]={4,210};
 printf_xy(3,15,"SCORE: %ld",punkte);
 randomize();
 if (gegner==1) saveuboote=3-(rand()%2);
 if (gegner==2) saveuboote=6-(rand()%2);
 if (gegner==3) saveuboote=9-(rand()%2);
 if (bomben==1) numbombs=6;
 if (bomben==2) numbombs=4;
 if (bomben==3) numbombs=2;
 explo=0;
 
 saveu=saveuboote;
 lebenskasten();
 lebensenergie(schiffleben);

 printf_xy(3,5,"LIFE");
 printf_xy(200,15,"U-BOOTS: %d",saveu);
 
					
 //=========================================
 speed=0;


 do
 {
    FontSetSys(F_4x6);
   printf_xy(3,5,"LIFE");
 if (kbhit())
  {
   key=ngetchx();
   if (key==337) {//nach links 
                  speed=speed-1; if (speed<-3) speed=-3; 
                 }
   if (key==340) {//nach rechts
                  speed=speed+1; if (speed>3) speed=3;
                 }
   if (key==268) {//linke bombe lsen
   								if (numbombs!=0){  
   								bombe[bombsfalling].x=0;
 	 								bombe[bombsfalling].y=0;								
                  bombe[bombsfalling].x=schiffx+1;
 	 								bombe[bombsfalling].y=25;
 	 								numbombs-=1;
   								} 
                 }
   if (key==269) {//rechte bombe lsen
   								if (numbombs!=0)
   								{
   								bombe[bombsfalling].x=0;
	 								bombe[bombsfalling].y=0;
                  bombe[bombsfalling].x=schiffx+22;
 	 								bombe[bombsfalling].y=25;
 	 								numbombs-=1;
 	 								} 
                 }

  }

 //=========fallenden bomben==================================
 for (tt=0;tt<=5;tt++)
   {
    if (bombe[tt].y!=0)
    {
				   	if (bombe[tt].y>=120)
				   	{
				     Sprite8(bombe[tt].x,bombe[tt].y,5, deletebomb, GetPlane(1),A_XOR);
					   bombe[tt].x=0;
						 bombe[tt].y=0;	
						 bombsfalling=tt;
						 numbombs+=1;
						 punkte-=150;
						 if (punkte<=0) punkte=0;
						 printf_xy(3,15,"SCORE:                            ");
						 printf_xy(3,15,"SCORE: %ld",punkte);
				   	}
				   	else
				   	{
						 Sprite8(bombe[tt].x,bombe[tt].y,5, bomb, GetPlane(1),A_OR);
						 bombe[tt].y=(bombe[tt].y)+1;
						 Sprite8(bombe[tt].x,bombe[tt].y,5, bomb, GetPlane(1),A_XOR);
						}
		}
		else bombsfalling=tt;
   }
  FontSetSys(F_4x6);

//==========uboote bewegungen + schiessen=================================
	if (first==0)//erster aufruf und dann nichts mehr
    {
	    for (tt=0;tt<saveuboote;tt++)
	    { 
	      randomize();
        bb+=1; bb+=rand()%1;if (bb>3) bb=1;
        cc+=1; if (cc>1) cc=0;
        if (saveuboote<=2) uboot[tt].x=60+(tt*35);
		    if (saveuboote>2&&saveuboote<=5) uboot[tt].x=45+(tt*10); 
		    if (saveuboote>5) uboot[tt].x=40+(tt*9);
		    uboot[tt].y=lry[cc];
		    randomize();
		    uboot[tt].sp=bb; 
	    }
      first=1;   
    }   
    
    
	for (tt=0;tt<saveuboote;tt++)
		  {
		  if (uboot[tt].y!=0)
		   {
		    if (uboot[tt].richtung==0)
		    {
			    uboot[tt].y=(uboot[tt].y)+uboot[tt].sp;
			    Sprite32(uboot[tt].y,uboot[tt].x, 7, uright, GetPlane(1), A_OR);
			    if (uboot[tt].y>=210) uboot[tt].richtung=1;
			    Sprite32 (uboot[tt].y,uboot[tt].x, 7, uright, GetPlane(1), A_XOR);
		    }
		    
		    if (uboot[tt].richtung==1)
		    {
			    uboot[tt].y=(uboot[tt].y)-uboot[tt].sp;
			    Sprite32 (uboot[tt].y,uboot[tt].x, 7, uleft, GetPlane(1), A_OR);
			    if (uboot[tt].y<=4) uboot[tt].richtung=0;
			    Sprite32 (uboot[tt].y,uboot[tt].x, 7, uleft, GetPlane(1), A_XOR);
		    }
	     }	 
	    short bb;
			if (uboot[tt].uschuss.ausgeloest==0)
			{
			randomize();
			if (ki==1) 
			{
				if ((uboot[tt].y>schiffx-30)&&(uboot[tt].y<schiffx+50))
				{
				bb=20;
					if (rand()%bb==2)
					{
					 uboot[tt].uschuss.ausgeloest=1;
					 uboot[tt].uschuss.y=uboot[tt].x-4;
					 uboot[tt].uschuss.x=uboot[tt].y+9;
					}
				}
			}
			if (ki==2) 
			{
				if ((uboot[tt].y>schiffx-20)&&(uboot[tt].y<schiffx+40))
				{
				bb=10;
					if (rand()%bb==2)
					{
					 uboot[tt].uschuss.ausgeloest=1;
					 uboot[tt].uschuss.y=uboot[tt].x-4;
					 uboot[tt].uschuss.x=uboot[tt].y+9;
					}
				}
			}
			if (ki==3) 
			{
				if ((uboot[tt].y>schiffx-10)&&(uboot[tt].y<schiffx+30))
				{
				bb=3;
					if (rand()%bb==2)
					{
					 uboot[tt].uschuss.ausgeloest=1;
					 uboot[tt].uschuss.y=uboot[tt].x-4;
					 uboot[tt].uschuss.x=uboot[tt].y+9;
					}
				}
			}
			
		
			}
			else
			{
					 if (uboot[tt].uschuss.y<=33)
						   	{
						     Sprite8(uboot[tt].uschuss.x,uboot[tt].uschuss.y,4, deletebomb, GetPlane(1),A_XOR);
							   uboot[tt].uschuss.y=0;
								 uboot[tt].uschuss.x=0;	
                 uboot[tt].uschuss.ausgeloest=0;
						   	}
						   	else
						   	{
								 uboot[tt].uschuss.y=(uboot[tt].uschuss.y)-1;															  
								 Sprite8(uboot[tt].uschuss.x,uboot[tt].uschuss.y,4,bombuboot, GetPlane(1),A_OR);				 
								 Sprite8(uboot[tt].uschuss.x,uboot[tt].uschuss.y,4,bombuboot, GetPlane(1),A_XOR);	
			   			  }						
      }
 
}
//============treffer von ubooten==========================
	for (kk=0;kk<saveuboote;kk++)
	{
			for (tt=0;tt<=5;tt++)
	     { 																																																																																							
	      if (((bombe[tt].x+5)>=(uboot[kk].y+4)&&(bombe[tt].x+2)<=(uboot[kk].y+26))&&(!((bombe[tt].y+2)>=(uboot[kk].x+6))&&((bombe[tt].y+2)>=(uboot[kk].x+3))))
	        {        
			      Sprite8(bombe[tt].x,bombe[tt].y,5, deletebomb, GetPlane(1),A_XOR);
			      if (uboot[kk].richtung==0) Sprite32 (uboot[kk].y,uboot[kk].x, 7, urightdestroy, GetPlane(1), A_XOR);
						if (uboot[kk].richtung==1) Sprite32 (uboot[kk].y,uboot[kk].x, 7, uleftdestroy, GetPlane(1), A_XOR);
						zeit(888);Sprite32(uboot[kk].y,uboot[kk].x, 7, deluboot, GetPlane(1), A_XOR);
					  bombe[tt].x=0;
						bombe[tt].y=0;	
						bombsfalling=tt;
						numbombs+=1;
						uboot[kk].x=0;
						uboot[kk].y=0;
					  for (zz=0;zz<saveuboote-1;zz++)
						 {
						  if (uboot[zz].x==0&&uboot[zz].y==0) 
						  {
						  uboot[zz].x=uboot[zz+1].x;
						  uboot[zz].y=uboot[zz+1].y;
						  uboot[zz+1].x=0;
						  uboot[zz+1].y=0; 
						  }					 
						 }
						 saveu-=1;
						 FontSetSys(F_4x6);
						 
						 if (leben==1) xp=1+(trunc(uboot[kk].x/8));
						 if (leben==2) xp=5+(trunc(uboot[kk].x/6));
						 if (leben==3) xp=60+(trunc(uboot[kk].x/3));
						 if (bomben==1) yp=1+(trunc(uboot[kk].x/8));
						 if (bomben==2) yp=5+(trunc(uboot[kk].x/6));
						 if (bomben==3) yp=50+(trunc(uboot[kk].x/3));
						 if (gegner==1) zp=1+(trunc(uboot[kk].x/8));
						 if (gegner==2) zp=5+(trunc(uboot[kk].x/6));
						 if (gegner==3) zp=50+(trunc(uboot[kk].x/3));
						 if (ki==1) wp=1+(trunc(uboot[kk].x/8));
						 if (ki==2) wp=5+(trunc(uboot[kk].x/6));
						 if (ki==3) wp=150+(trunc(uboot[kk].x/3));
						 
						 punkte+=(xp+yp+zp+wp);
						 printf_xy(3,15,"SCORE: %ld",punkte);
						 printf_xy(200,15,"U-BOOTS: %d",saveu);
						 if (saveu==0) 
						 {
						 FontSetSys(F_6x8);
						 printf_xy(95,5,"NEXT ROUND");
						 FontSetSys(F_4x6);
						 besiegt=0;
						 ende=1;
						 }
			     } 
			  }
  }

//////////  ob uboote getroffen haben //////////////////


for (kk=0;kk<=saveuboote;kk++)
	{
		  if (((uboot[kk].uschuss.x+4>=schiffx+7)&&(uboot[kk].uschuss.x+3<=schiffx+24))&&(((uboot[kk].uschuss.y==33)&&(uboot[kk].uschuss.y!=0)||(uboot[kk].uschuss.y==32)&&(uboot[kk].uschuss.y!=0))))
	        {        
			      Sprite8(uboot[tt].uschuss.x,uboot[tt].uschuss.y,5, deletebomb, GetPlane(1),A_XOR);
			      if (leben==1) schiffleben-=10;
			      if (leben==2) schiffleben-=20;
			      if (leben==3) schiffleben-=40;
			      lebensenergie(schiffleben);			      
			      
			      FontSetSys(F_4x6);
 	          printf_xy(3,5,"LIFE");				
			       if (schiffleben<=0) 
						 {
						 explosion=1;

						 }
			     } 
		}

 if (explosion==1) schiffexplosion();

//////////////////////////////////////////////////////////////////////////

 if (explosion==0) schiffbewegung();
 zeit(9999);
 FontSetSys(F_4x6);
 printf_xy(200,5,"BOMBS   : %d",numbombs);
 }
 while(ende==0&&key!=264);
	 if (besiegt==1) 
	 {
		if (ishighscore(punkte)==1)
		 {
		   eingabe(punkte);
		   sortieren();
		 }
	 anzeigehighscore(); //////////anzeige des highscores-------------------------------------------------
	 if (key!=264&&besiegt==1) ngetchx();
	 } 
	 if (besiegt==0) 
	 {
	  if (key!=264&&besiegt==0) ngetchx();
	  ende=0;
	  schiffx=100;
	  paintbackground(back1_layer2,back1_layer1);
	 }
}while(key!=264&&besiegt==0);
		paintbackground(back3_layer2,back3_layer1);
}
//=========================================================//
void _main(void)
{
unsigned short int keyy,wert=40,wahl;


dateivorhanden();
datenauslesen();
GrayMode(GRAY_ON);
paintbackground(anfang22,anfang2);
ngetchx();
paintbackground(back3_layer2,back3_layer1);

Sprite8(40,wert, 8,cursor, GetPlane(1), SPRT_OR);
 wahl=0;
  do
  {  
   Sprite8(40,wert, 8,cursor, GetPlane(1), SPRT_OR);
   if (wahl==0)
   {  	
  	wert=40;  
   }
    wahl=1;
    keyy=ngetchx();
			   if (keyy==344) 
			    {
			    Sprite8(40,wert, 8, cursor_leer,GetPlane(1), A_XOR);
			    wert=wert+13;
			    if (wert>66&&wert<83) wert=83;
			    if (wert>84) wert=40;
			    
			    }
			   if (keyy==338) 
			    {
			    Sprite8(40,wert, 8, cursor_leer,GetPlane(1), A_XOR);
			    wert=wert-13;
			    if (wert<83&&wert>66) wert=66;
			    if (wert<40) wert=83;
			    }
			   if (keyy==268) {anzeigehighscore();ngetchx();paintbackground(back3_layer2,back3_layer1);}
   if (keyy==13)
    {
     if (wert==40) {paintbackground(back1_layer2,back1_layer1);schiffx=100;game();}
     if (wert==53) {options();paintbackground(back3_layer2,back3_layer1);};
     if (wert==66) {scroller();paintbackground(back3_layer2,back3_layer1);};
     
     if (wert==83) wahl=4;
    }
   if (keyy!=13&&keyy!=344&&keyy!=338){Sprite8(40,wert, 8, deletebomb, GetPlane(1), A_OR);} 
  
   
  }
  while(wahl!=4&&keyy!=264);
savescore();
GrayMode(GRAY_OFF);
}
//================================================================